SystemOrganization addCategory: #'Seaside-Tests-Slime'!

WAObject subclass: #WASlimeMockWAObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockWAObject methodsFor: 'accessing' stamp: 'lr 2/24/2009 17:05'!
deprecated
	self seasideDeprecatedApi: 'WASlimeMock>>#deprecatedMethod' details: 'Something.'! !

!WASlimeMockWAObject methodsFor: 'initialization' stamp: 'lr 11/14/2008 23:57'!
initialize! !

!WASlimeMockWAObject methodsFor: 'copying' stamp: 'lr 11/14/2008 23:57'!
postCopy! !

!WAPackage class methodsFor: '*seaside-tests-slime' stamp: 'jf 1/11/2009 14:12'!
seasideTestsSlime
	^ self new
		name: 'Seaside-Tests-Slime';
		description: 'Unit tests for the package Seaside-Slime.';
		addDependency: 'Seaside-Slime';
		addDependency: 'Seaside-Tests-Component';
		yourself! !

Object subclass: #WASlimeMockObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockObject methodsFor: 'accessing' stamp: 'lr 1/11/2009 23:41'!
braceMessage
	Array braceWithNone! !

!WASlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:44'!
callbackTemps
	| r |
	r := OrderedCollection new.
	(1 to: 10) do: [ :e | r add: [ e ] ]! !

!WASlimeMockObject methodsFor: 'initialization' stamp: 'lr 11/14/2008 23:59'!
initialize
	super initialize! !

!WASlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:13'!
someClass
	Semaphore new! !

!WASlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:26'!
someMessage
	^ true and: [ false ] and: [ nil ]! !

WASession subclass: #WASlimeMockSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockSession methodsFor: 'as yet unclassified' stamp: 'pmm 10/18/2008 20:27'!
expired! !

WAComponent subclass: #WASlimeMockComponent
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:21'!
renderAvoidUnnecessaryWithOn: html
	html div with: 'foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:36'!
renderChangesStateWhileRenderingOn: html
	html div: [ foo := nil ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:24'!
renderContentOn: html
	super renderContentOn: html! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:17'!
renderDoNotUseWhileRenderingOn: html
	html div: [ self call: foo ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'jf 1/22/2009 22:44'!
renderDoNotUseWithinCallbackOn: html
	html anchor
		callback: [ html document addLoadScript: nil ];
		with: 'foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:22'!
renderExtractCallbackCodeToMethodOn: html
	html anchor callback: [ self foo. self bar ]; with: 'foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'jf 1/11/2009 14:11'!
renderInstantiatesComponentWhileRenderingOn: html
	html div: WAComponentMock new! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:38'!
renderSendsDeprecatedMessageOn: html
	html anchor src: 'http://www.foo.com'; with: 'Foo'! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:35'!
renderUnnecessaryBlockPassedToBrushOn: html
	html div: [ html render: 'foo' ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:08'!
renderUsesWrongRendererOn: html
	html updater callback: [ :r | html div ]! !

!WASlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:27'!
renderWithHasToBeLastMessageInCascadeOn: html
	html div
		with: 'foo';
		class: 'bar'! !

!WASlimeMockComponent methodsFor: 'actions' stamp: 'lr 7/15/2008 23:26'!
sendsRenderContentOn
	self renderContentOn: nil! !

TestCase subclass: #WASlimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!WASlimeTest methodsFor: 'actions' stamp: 'lr 1/11/2009 22:31'!
run: aRule selectors: aSelectorCollection 
	self 
		run: aRule
		selectors: aSelectorCollection
		in: (Array 
			with: WASlimeMockComponent
			with: WASlimeMockObject
			with: WASlimeMockSession
			with: WASlimeMockWAObject)! !

!WASlimeTest methodsFor: 'actions' stamp: 'lr 7/15/2008 23:41'!
run: aRule selectors: aSelectorCollection in: aClassCollection 
	| searchEnvironment resultEnvironment |
	searchEnvironment := ClassEnvironment 
		onEnvironment: BrowserEnvironment new
		classes: aClassCollection.
	SmalllintChecker
		runRule: aRule
		onEnvironment: searchEnvironment.
	resultEnvironment := aRule result.
	self assert: resultEnvironment problemCount = aSelectorCollection size.
	aSelectorCollection do: [ :selector |
		self assert: (resultEnvironment classes
			anySatisfy: [ :class | resultEnvironment includesSelector: selector in: class ]) ]! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:56'!
testAvoidUnnecessaryWith
	self 
		run: WAAvoidUnnecessaryWithRule new
		selectors: #(renderAvoidUnnecessaryWithOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:57'!
testBasicNewInitializeMissing
	self 
		run: WABasicNewInitializeMissingRule new
		selectors: #(initialize)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:58'!
testChangesStateWhileRendering
	self 
		run: WAChangesStateWhileRenderingRule new
		selectors: #(renderChangesStateWhileRenderingOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 17:06'!
testDeprecatedApiProtocol
	self 
		run: WADeprecatedApiProtocolRule new
		selectors: #(deprecated)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:58'!
testDoNotUseWhileRendering
	self 
		run: WADoNotUseWhileRenderingRule new
		selectors: #(renderDoNotUseWhileRenderingOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:58'!
testDoNotUseWithinCallback
	self 
		run: WADoNotUseWithinCallbackRule new
		selectors: #(renderDoNotUseWithinCallbackOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:58'!
testDontCallSuperInitialize
	self 
		run: WAInvalidObjectInitializationRule new
		selectors: #(initialize)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:59'!
testExtractCallbackCodeToMethod
	self 
		run: WAExtractCallbackCodeToMethodRule new
		selectors: #(renderExtractCallbackCodeToMethodOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:59'!
testFixCallbackTempsMissing
	self 
		run: WAFixCallbackTempsMissingRule new
		selectors: #(callbackTemps)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 15:59'!
testInstantiatesComponentWhileRendering
	self 
		run: WAInstantiatesComponentWhileRenderingRule new
		selectors: #(renderInstantiatesComponentWhileRenderingOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:00'!
testSendsNotPortableMessage
	self 
		run: WASendsNotPortableMessageRule new
		selectors: #(someMessage)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:00'!
testSendsRenderContentOn
	self 
		run: WASendsRenderContentOnRule new
		selectors: #(sendsRenderContentOn)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:00'!
testUnnecessaryBlockPassedToBrush
	self 
		run: WAUnnecessaryBlockPassedToBrushRule new
		selectors: #(renderUnnecessaryBlockPassedToBrushOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:00'!
testUsesCurlyBraceArrays
	self 
		run: WAUsesCurlyBraceArraysRule new 
		selectors: #(braceMessage)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 17:05'!
testUsesDeprecatedClass
	self 
		run: WAUsesDeprecatedClassRule new
		selectors: #()! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:01'!
testUsesLiteralByteArrays
	self 
		run: WAUsesLiteralByteArraysRule new
		selectors: #()! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:01'!
testUsesNotPortableClass
	self 
		run: WAUsesNotPortableClassRule new
		selectors: #(someClass)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:01'!
testUsesWrongRenderer
	self 
		run: WAUsesWrongRendererRule new
		selectors: #(renderUsesWrongRendererOn:)! !

!WASlimeTest methodsFor: 'testing' stamp: 'lr 2/24/2009 16:01'!
testWithHasToBeLastMessageInCascade
	self 
		run: WAWithHasToBeLastMessageInCascadeRule new
		selectors: #(renderWithHasToBeLastMessageInCascadeOn:)! !
